<?php
#-----------------------------------------------------------------------
# display source of script if requested so
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
#
$pageName	= 'wsDataGet.php';
if (!isset($SITE)){echo "<h3>invalid call to script $pageName</h3>";exit;}
$pageVersion	= '3.11 2015-11-22';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
#
if (!function_exists ('ws_message') ){
        function ws_message ($message,$always=false,&$string=false) {
                global $wsDebug, $SITE;
                $echo	= $always;
                if ( $echo == false && isset ($wsDebug) && $wsDebug == true ) 			{$echo = true;}
                if ( $echo == false && isset ($SIE['wsDebug']) && $SIE['wsDebug'] == true ) 	{$echo = true;}
                if ( $echo == true  && $string === false) {echo $message.PHP_EOL;}
                if ( $echo == true  && $string <>  false) {$string .= $message.PHP_EOL;}
        }
}
ws_message ( '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->");
#-----------------------------------------------------------------------
# 3.11 2015-11-22 release 2.7 version + missing WD-CCN  modified for yahoo problems
# ----------------------------------------------------------------------
#
#               get current weather values and yesterday values 
$fileToLoad     = $SITE['wsTags'];
$useUpload	= true;
$uoms		= $uomTemp.$uomBaro.$uomWind.$uomRain.$uomSnow.$uomDistance.$uomPerHour.$uomHeight;
$from		= array('/',' ','&deg;','.php','.htm','.txt','.');
$to		= '';
$cachedFile	= $SITE['cacheDir'].str_replace ($from, $to, $fileToLoad.$uoms);  // add uoms
#
if (file_exists($fileToLoad)){
        $fileTimeUpload	= filemtime($fileToLoad); } 
else {  $fileTimeUpload	= 11;   // no upload found, set date time to nill to force use of cache
        echo '<!-- no upload of tags file  '.$fileToLoad.' found - try cache -->'.PHP_EOL;
}
if ($save_to_cache &&  file_exists($cachedFile) ){
	$fileTimeCache	= filemtime($cachedFile); 
	if ($fileTimeCache > $fileTimeUpload) {
		echo '<!--  data get cache ('.$cachedFile.') 
        data file  ('.$fileToLoad.")
        cache time   = ".date('c',$fileTimeCache)." from unix time $fileTimeCache
        data  time   = ".date('c',$fileTimeUpload)." from unix time $fileTimeUpload  -->".PHP_EOL;	
		$useUpload	= false;
		echo '<!-- '.$fileToLoad.' older than cached file, cache used  -->'.PHP_EOL;} 
	else {  echo '<!-- '.$fileToLoad.' will be loaded, more recent than cached file.  -->'.PHP_EOL;}
}
switch ($useUpload) {
  case true:
	echo '<!-- loading '.$SITE['process'].' -->'.PHP_EOL;
	include($SITE['process']);				// current weatherdata
	if (isset ($SITE['wsYTags'])  && $SITE['wsYTags']  <> 'no') {
		echo '<!-- loading '.$SITE['wsYTags'].' -->'.PHP_EOL;
		include($SITE['wsYTags']); }   		        // yesterday values 
	if (!isset ($ws['actTime']) ) {
		$useUpload = false;				// check if correct file was read
		echo '<!-- uploaded file incorrect - reverting to cached file -->'.PHP_EOL;
	        $ws = unserialize(file_get_contents($cachedFile));
	        echo '<!-- loading tag files from '.$cachedFile.' -->'.PHP_EOL;
	        if (!isset ($ws['actTime']) ) { exit ('<h3>loading '.$SITE['process'].' - uploaded file incorrect<br /> 
reverting to cached file - loading tag files from '.$cachedFile.' - no valid tags file found <br />
program halts </h3>'); }
		break; 
	}
# save site information in ws array
	if (!$save_to_cache) {break;}
#	
        $ws['fileTime'] = $fileTimeUpload;
#
        if (!isset ($wsTrends) ) { 
                echo '<!-- no trends to cache -->'.PHP_EOL;
        } else { $ws['trendsExist'] = $cacheTrends = $cachedFile.'_trends';       
                if (!file_put_contents($cacheTrends, serialize($wsTrends)) )
                        { echo PHP_EOL.'<!-- Could not save data (trends) to cache ('.$cacheTrends.'). Please make sure your cache directory exists and is writable. -->'.PHP_EOL;} 
                else    { echo '<!-- Weatherdata trends saved to cache ('.$cacheTrends.')  -->'.PHP_EOL;}
        }
#
        if (!file_put_contents($cachedFile, serialize($ws)) )
                { echo PHP_EOL.'<!-- Could not save tags from '.$ws['actTime'].' to cache ('.$cachedFile.'). Please make sure your cache directory exists and is writable. -->'.PHP_EOL;} 
        else    { echo '<!-- Weatherdata tags from '.$ws['actTime'].' - saved to cache ('.$cachedFile.')  -->'.PHP_EOL;}
#
   break;
   default:
	$ws = unserialize(file_get_contents($cachedFile));
	echo '<!-- loading tag files from '.$cachedFile.' -->'.PHP_EOL;
	if (!isset ($ws['actTime']) ) { exit ('<h3>no valid tags file found - program halts </h3>'); }
} // eo switch
if (isset ($realtime) && $realtime) {return;}
# 
# now calculate missing items for dashboard - day night switch and so on
#
$nowInt		= time();
$now		= date($SITE["timeOnlyFormat"],$nowInt);
$lat		= $SITE['latitude'];
$long		= $SITE['longitude'];
$sunriseInt	= date_sunrise($nowInt, SUNFUNCS_RET_TIMESTAMP, $lat, $long);   // standard time integer
$sunsetInt	= date_sunset ($nowInt, SUNFUNCS_RET_TIMESTAMP, $lat, $long);
$one_day        = 24*60*60;
$sunriseIntYday	= date_sunrise(($nowInt - $one_day), SUNFUNCS_RET_TIMESTAMP, $lat, $long);   // standard time integer
$sunsetIntYday	= date_sunset (($nowInt - $one_day), SUNFUNCS_RET_TIMESTAMP, $lat, $long);
$daylight       = abs($sunsetInt - $sunriseInt);
$daylightYday   = abs($sunsetIntYday - $sunriseIntYday);
$daylight_hrs   = floor ($daylight/3600);
$daylight_min   = floor ( ($daylight - (3600 * $daylight_hrs) ) / 60  );    
$daylight_txt   = langtransstr('Daylight hh:mm') .' '.$daylight_hrs.':'.substr('0'.$daylight_min,-2);
$less_more      = round ( ($daylight - $daylightYday) / 60 );
#echo "daylight = $daylight  - daylightYday = $daylightYday".PHP_EOL; exit;
if ($less_more < 0) 
        {$daylight_trend        =  '- '.$less_more.' '.langtransstr('minutes');} 
else    {$daylight_trend        =  '+ '.$less_more.' '.langtransstr('minutes');} 
$ws['daylight_text']            = $daylight_txt;
$ws['daylight_trend']           = $daylight_trend;
$ws['daylight']                 = $ws['daylight_text'] .' ('. $ws['daylight_trend'].')';
#
$sunrise	= $ws['sunrise']	= date($SITE["timeOnlyFormat"],$sunriseInt);
$sunset		= $ws['sunset']		= date($SITE["timeOnlyFormat"],$sunsetInt);
if (isset ($ws['moonrise'])  && $ws['moonrise'] <> 0){
	$string = ' Thu, 21 Dec 2000 '.$ws['moonrise'];
	$ws['moonrise'] = date($SITE["timeOnlyFormat"],strtotime($string));}
#
if (isset ($ws['moonset'])  && $ws['moonset'] <> 0){
	$string = ' Thu, 21 Dec 2000 '.$ws['moonset'];
	$ws['moonset'] = date($SITE["timeOnlyFormat"],strtotime($string));}
#
if (($nowInt >= $sunriseInt) && ($nowInt <= $sunsetInt)) {
	$dayNight = 'daylight';} 
else {  $dayNight = 'nighttime';}
#
if ($wsDebug) { echo "<!-- wsDataGet.php time  is $nowInt => $now  | it is  $dayNight | sunrise at $sunriseInt => $sunrise  | sunset at  $sunsetInt => $sunset -->".PHP_EOL;}
include_once    'wsIconUrl.php';
#---------------------- and now get the current conditions from some source --------------
if ($wsDebug) { echo '<!-- wsDataGet.php $SITE["curCondFrom"] = '.$SITE['curCondFrom'].'  -->'.PHP_EOL;}
#
switch ($SITE['curCondFrom']) {	
	case 'yahoo':
                include_once('forecasts/yahoo.weather2.php');
                $weather 	= new yahooWeather();
                $yahooArray	= $weather->getWeatherData($SITE['yaPlaceID']);
                if (isset ($yahooArray['ccn']) ) {
                        $condDesc       = cleanCurCond($yahooArray['ccn']['1']['text']);
                        $ccnIconNr	= $iconIn 	= $yahooArray['ccn']['1']['icon'];
                        $ccnIconUrl	= $urlIn	= $yahooArray['ccn']['1']['iconUrl'];
                        wsChangeIcon ('yahoo',$iconIn, $ccnIconNr, $urlIn, $ccnIconUrl);		
                        $headerClass    = wsHeaderLookup ('yahoo',$iconIn);
	                break;
	        }
	        $SITE['curCondFrom'] = 'metar switched from yahoo';
	        ws_message ( '<!-- module wsDataGet.php ('.__LINE__.'): $SITE["curCondFrom"] = '.$SITE['curCondFrom'].'  -->',true);
	case 'wd':
		if (isset ($ws['wdCurCond']) && isset ($ws['wdCurIcon'])) {
			$condDesc       = cleanCurCond($ws['wdCurCond']);
			$ccnIconNr	= $ccnIconUrl = $urlIn	= $notUsed	= '';
			wsChangeIcon ('wd',$ws['wdCurIcon'], $ccnIconNr, $urlIn, $ccnIconUrl);
			$headerClass= wsHeaderLookup ('wd',$ws['wdCurIcon']);	
			break;
		}
	default:
                include $SITE['metarDir'].'wsMetarXml.php';
                $end		= count ($arrConditions);
                $condDesc       = '';
                for ($i = 0; $i < $end; $i++) {
                        $condDesc .= langtransstr($arrConditions[$i]['txt']).'<br />';
	        }
                if ($coverDescription == 'Clear' && $dayNight <> 'nighttime') {$coverDescription = 'sunny';}
                $condDesc       .= langtransstr($coverDescription);
                if ($dayNight == 'nighttime') {$iconNrPr .='n';}
                $icon		= $iconNrPr;
                wsChangeIcon ('default',$icon, $icon, '', $ccnIconUrl);
                $ccnIconNr      = $iconNrPr;
                $headerClass    = wsHeaderLookup ('default',$iconNrPr);	
	break;
}
if ($SITE['wuPage'] == 'yes' || $SITE['wuPage'] == true) {
        if ($wsDebug) { echo '<!-- wsDataGet.php  loading almanac data from wu -->'.PHP_EOL;}
        include './wuforecast/wualmanac.php';
}
return;
#-----------------------------------------------------------------------------------------
function cleanCurCond($words) {                 // used for WD and Yahoo
	$arrTxt = explode ('/',$words);		// AM Light Snow/ Drizzle late
	$cndTxt = '';
	$iEnd   = count($arrTxt)-1;
	for ($i2 = 0; $i2 <= $iEnd; $i2++ ) {
	        $text   = $arrTxt[$i2];
		if ($text <> '') {
			if (substr($text,0,2) == 'AM') {
				$cndTxt .= langtransstr('Morning'). ': ';
				$text   = substr($text,2);
			}
			if (substr($text,0,2) == 'PM') {
				$cndTxt .= langtransstr('Afternoon'). ': ';
				$text   = substr($text,2);
			}
			if (substr($text,-5) == ' Late') {
				$cndTxt .= langtransstr('Late'). ': ';
				$text   = substr($text,0,strlen($text)-5);
			}				
			if (substr($text,0,2) == 'PM') {
				$cndTxt.= langtransstr('Afternoon'). ': ';
				$text   = substr($text,2);
			}			
			$cndTxt         .=langtransstr($text);
			if ($iEnd > $i2) { $cndTxt  .= '<br />';}
		}
	}
	return( $cndTxt);
}
